/**
 * Class to handle the preferences menu.
 * 
 * Copyright (C) 2002 Brian Enigma <enigma@netninja.com>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: PrefsMenu.java,v 1.2 2002/04/16 04:09:09 enigma Exp $
 */

import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;

public class PrefsMenu
implements CommandListener
{
    /** MIDlet */
    MIDlet midlet;
    /** "Back" button form */
    Displayable backForm;
    /** GUI form **/
    Form prefForm;
    /** Preferences object */
    Prefs preferences;
    /** Username */
    TextField uidText;
    /** Password */
    TextField pwdText;
    /** Cancel command */
    Command cancelCommand = new Command("Cancel", Command.CANCEL, 1);
    /** Save command */
    Command saveCommand = new Command("Save", Command.OK, 1);


    /** Cannot construct this way */
    private PrefsMenu() {}

    /** Constructor */
    public PrefsMenu(MIDlet midlet, Displayable backForm, Prefs preferences)
    {
        this.midlet = midlet;
        this.backForm = backForm;
        this.preferences = preferences;
        uidText = new TextField("Username", preferences.getUid(), 
            20, TextField.ANY);
        pwdText = new TextField("Password", preferences.getPwd(), 
            20, TextField.ANY);
        prefForm = new Form("Login Settings");
        //prefForm.append(new StringItem("LiveJournal Login Settings", null));
        prefForm.append(uidText);
        prefForm.append(pwdText);
        prefForm.addCommand(cancelCommand);
        prefForm.addCommand(saveCommand);
        prefForm.setCommandListener(this);
    }

    public void show()
    {
        Display.getDisplay(midlet).setCurrent(prefForm);
    }

    public void commandAction(Command c, Displayable d)
    {
        if (c == cancelCommand)
        {
            preferences.revert();
            Display.getDisplay(midlet).setCurrent(backForm);
        } else if (c == saveCommand) {
            preferences.setUid(uidText.getString());
            preferences.setPwd(pwdText.getString());
            preferences.store();
            // I really hate this...need to find a better way...
            ((MobileLJ)midlet).modifyList();
            Display.getDisplay(midlet).setCurrent(backForm);
        }
    }


}
